/*
 *	url2kanji	restore kanji character from url string
 *			programmed in 2001 10/20 by Nakata H.
 *			this program is distributed under GPL
 */
#include <stdio.h>

/*	main & only 1 function	---------------------------------------------*/
int	main()
{
  int	i;
  char	c, escape_char;
  char	string[3];
  int	escape_sequence = 0;

  while ( (i = getchar()) != EOF ) {
    switch ( escape_sequence ) {
    case 0:
      if ( i == '%' ) {
	escape_sequence = 1;
      } else {
	putchar(i);
      }
      break;
    case 1:
      if ( ! isxdigit(i) ) {
	escape_sequence = 0;
	putchar(i);
      } else {
	escape_sequence = 2;
	escape_char = i;
      }
      break;
    case 2:
      if ( ! isxdigit(i) ) {
	putchar(escape_char);
	putchar(i);
      } else {
	string[0] = escape_char;
	string[1] = i;
	string[2] = '\0';
	sscanf( string, "%2x", &i );
	putchar(i);
      }
      escape_sequence = 0;
      break;
    }
  }
  return (0);
}
/*	EOF	**************************************************************/
